'Binary Clock
'By: Keph (mail@keph.ca)
'Date: December 11, 2003
'This is a binary clock inspired by the binary clock for sale at
'http://www.thinkgeek.com/cubegoodies/lights/59e0/
'If you don't know how to read it, check out their site for instructions!
'This is my first real script, so I don't imagine it's very efficient.
'If anyone can make it better, please do!
'There are two functions included in this script - one uses the new png
'image capabilities to show nice png images for lights and the other is 
'text based. The png version is very processor intensive!
'A pre-exported demo config is also included.
'If you're going to use the png version, be sure to change the paths to the
'on/off images. This is located at the top of the binary_clock.vbs file.

'Define public variables
Public OnPNG, OffPNG
Public current_time(6)
Public binary(10, 4)

    'These are the paths to the images used when the clock lights are on or off.
    'Be sure to change these to the proper path for your system!
    OnPNG = "D:\Program Files\Samurize\Skins\BinaryClock\onpng.png"
    OffPNG = "D:\Program Files\Samurize\Skins\BinaryClock\offpng.png"

    'Here the binary equivalents of each digit (0-9) are saved in the array called binary.
    binary(0, 1) = False
    binary(0, 2) = False
    binary(0, 3) = False
    binary(0, 4) = False
    binary(1, 1) = True
    binary(1, 2) = False
    binary(1, 3) = False
    binary(1, 4) = False
    binary(2, 1) = False
    binary(2, 2) = True
    binary(2, 3) = False
    binary(2, 4) = False
    binary(3, 1) = True
    binary(3, 2) = True
    binary(3, 3) = False
    binary(3, 4) = False
    binary(4, 1) = False
    binary(4, 2) = False
    binary(4, 3) = True
    binary(4, 4) = False
    binary(5, 1) = True
    binary(5, 2) = False
    binary(5, 3) = True
    binary(5, 4) = False
    binary(6, 1) = False
    binary(6, 2) = True
    binary(6, 3) = True
    binary(6, 4) = False
    binary(7, 1) = True
    binary(7, 2) = True
    binary(7, 3) = True
    binary(7, 4) = False
    binary(8, 1) = False
    binary(8, 2) = False
    binary(8, 3) = False
    binary(8, 4) = True
    binary(9, 1) = True
    binary(9, 2) = False
    binary(9, 3) = False
    binary(9, 4) = True

'This is the PNG image version of the binary clock.
'The variable coordx and coordy represent the location in
'the grid of lights you would like to test. The light in the
'lower left-hand side is (1,1)
Function BinaryClock(coordx, coordy)
    'retrieve current time
    SetCurrentTime

    'Return the on or off image depending on the state of the requested light
    If binary(current_time(coordx), coordy) Then
        BinaryClock = OnPNG
    Else
        BinaryClock = OffPNG
    End If
End Function

'This is the text-based binary clock. It uses 1's and 0's to represent on's and off's
'You can experiment with different fonts and such - it looks best with simple
'fonts of uniform width.
Function TextBinaryClock
    'define variables
    Dim row, col

    'retrieve current time
    SetCurrentTime

    'construct the result with 1's and 0's
    For row = 4 To 1 step -1
        For col = 1 To 6
            If (binary(current_time(col), row)) Then
                result = result & "1 "
		if col = 6 then result = result & "%b"
                Else: result = result & "0 "
		if col = 6 then result = result & "%b"
            End If
        Next
    Next
    TextBinaryClock = result
End Function

'This function saves each of the digits from the current 12 hour time in an array called current_time.
Private Function SetCurrentTime
    'Store the digits from the current hour in the current_time array
    If Len(Hour(Now)) > 1 Then
        If Hour(Now) > 12 Then
            temp = CStr(CInt(Hour(Now) - 12))
            If Len(temp) > 1 Then
                current_time(1) = Mid(temp, 1, 1)
                current_time(2) = Mid(temp, 2, 1)
            Else
                current_time(1) = "0"
                current_time(2) = Mid(temp, 1, 1)
            End If
        Else
            current_time(1) = Mid(Hour(Now), 1, 1)
            current_time(2) = Mid(Hour(Now), 2, 1)
        End If
    Else
        current_time(1) = "0"
        current_time(2) = Mid(Hour(Now), 1, 1)
    End If

    'Store the digits from the current minute in the current_time array
    If Len(Minute(Now)) > 1 Then
        current_time(3) = Mid(Minute(Now), 1, 1)
        current_time(4) = Mid(Minute(Now), 2, 1)
    Else
        current_time(3) = "0"
        current_time(4) = Mid(Minute(Now), 1, 1)
    End If

    'Store the digits from the current second in the current_time array
    If Len(Second(Now)) > 1 Then
        current_time(5) = Mid(Second(Now), 1, 1)
        current_time(6) = Mid(Second(Now), 2, 1)
    Else
        current_time(5) = "0"
        current_time(6) = Mid(Second(Now), 1, 1)
    End If
End Function